import os
import subprocess

from poetry.core.utils._compat import Path
from poetry.core.utils._compat import decode

from .git import Git


def get_vcs(directory):  # type: (Path) -> Git
    cwd = str(directory.resolve())

    try:
        from .git import executable

        git_dir = decode(
            subprocess.check_output(
                [executable(), "rev-parse", "--show-prefix"], stderr=subprocess.STDOUT,
                cwd=cwd
            )
        ).strip()
        git_dir = git_dir.strip()[:-1]  # remove the trailing os.sep
        if not git_dir:
            git_dir = cwd
        else:
            git_dir = cwd[:-len(git_dir)]

        vcs = Git(Path(git_dir))

    except (subprocess.CalledProcessError, OSError, RuntimeError):
        vcs = None

    return vcs
